<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="标签组名称111" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入标签组名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="标签名称111" prop="name">
        <el-input
          v-model="queryParams.tagName"
          placeholder="请输入标签名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          size="mini"
          @click="handleSync"
          v-hasPermi="['qw:tagGroup:sync']"
        >同步</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['qw:tagGroup:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['qw:tagGroup:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['qw:tagGroup:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="tagGroupList" ref="tagGroupList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="名称" align="center" prop="name" />
      <el-table-column label="排序" align="center" prop="order" />
      <el-table-column label="标签" align="center" prop="tag" >
        <template slot-scope="scope" >
          <el-tag type="success" v-for="i in scope.row.tag" :key="i.id" style="margin-right: 5px;">{{i.name}}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['qw:tagGroup:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['qw:tagGroup:remove']"
          >删除</el-button>
        </template>
      </el-table-column>

    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="handlePaginationChange"
    />

    <div style="margin-top: 30px;display: flex;justify-content: center">
      <el-button type="warning" icon="el-icon-search" @click="confirmSelect">确定选择</el-button>
      <el-button icon="el-icon-refresh"  @click="resetSelect">重置选择</el-button>
    </div>

    <!-- 添加或修改企微客户标签组对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="排序" prop="order">
          <el-input-number v-model="form.order" placeholder="请输入排序" />
        </el-form-item>
        <el-row>
          <el-col :span="3"><div style="margin-top: 9px;font-weight: bold;float: right; margin-right: 10px;">标签</div></el-col>
          <el-col :span="21">
            <el-table :data="form.tag">
              <el-table-column label="名称" prop="name" align="center">
                <template slot-scope="scope">
                  <el-input v-model="scope.row.name"></el-input>
                </template>
              </el-table-column>
              <el-table-column label="排序" prop="order" align="center">
                <template slot-scope="scope">
                  <el-input-number v-model="scope.row.order"></el-input-number>
                </template>
              </el-table-column>
              <el-table-column label="操作" width="150px" align="center">
                <template slot-scope="scope">
                  <el-button @click="addRow" size="mini" type="text">新增</el-button>
                  <el-button @click="deleteRow(scope.$index)" size="mini" type="text" v-if="form.tag.length>1">删除</el-button>
                </template>
              </el-table-column>
            </el-table>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { syncTag, listTagGroup, getTagGroup, delTagGroup, addTagGroup, updateTagGroup, exportTagGroup } from "@/api/qw/tagGroup";

export default {
  name: "tagGroupList",
  props: {
    changeType: Number
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 企微客户标签组表格数据
      tagGroupList: [],
      // 选择的标签组
      selectTagsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        groupId: null,
        name: null,
        order: null,
        corpId: null,
        companyId: null,
      },
      tagJson: [],
      // 表单参数
      form: {},
      // 表单校验
      rules: {}
    };
  },
  created() {
    // this.getList();
  },
  methods: {

    getTagGroupList(row) {
      this.queryParams.corpId = row;
      this.getList();
    },
    /** 查询企微客户标签组列表 */
    getList() {
      this.loading = true;

      listTagGroup(this.queryParams).then(response => {
        this.tagGroupList = response.rows;
        this.total = response.total;
        this.loading = false;

      });
    },
    handlePaginationChange(row) {
      this.queryParams.pageNum = row.page;
      this.queryParams.pageSize = row.limit;
      this.getList();
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        groupId: null,
        name: null,
        order: null,
        corpId: null,
        companyId: null,
        createTime: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    // 确定选择
    confirmSelect() {
      this.$emit("selectTagsList", this.selectTagsList, this.changeType);
      this.resetSelect();
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    addRow() {
      this.form.tag.push({name: "标签", order: 0});
    },
    deleteRow(index) {
      this.form.tag.splice(index, 1);
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 重置选择
    resetSelect() {
      this.$refs.tagGroupList.clearSelection();
      this.selectTagsList = [];
      // 重置查询参数
      this.queryParams = {
        pageNum: 1,
        pageSize: 10,
        groupId: null,
        name: null,
        order: null,
        corpId: null,
        companyId: null,
      };
      this.getList();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      const currentPageSelections = selection.map(item => item.id);
      this.selectTagsList = this.selectTagsList.filter(item =>
        this.tagGroupList.some(tag => tag.id === item.id) ? currentPageSelections.includes(item.id) : true
      ).concat(selection.filter(item => !this.selectTagsList.some(selected => selected.id === item.id)));

      this.ids = this.selectTagsList.map(item => item.id);
      this.single = this.selectTagsList.length !== 1;
      this.multiple = !this.selectTagsList.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.form.tag = [
        {name: "标签", order: 0},
      ];
      this.title = "添加企微客户标签组";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getTagGroup(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改企微客户标签组";
      });
    },
    handleSync() {
      syncTag().then(response => {
        this.msgSuccess("同步成功");
        this.getList();
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateTagGroup(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTagGroup(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除企微客户标签组编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delTagGroup(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
  }
};
</script>
